<!DOCTYPE html>
<html lang="en">

<head>
    <title>task 41.55 Filter Users</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <!-- Import Datatable sau jquery -->
    <!-- Import them style bootstrap cho datatable -->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>

</head>

<body>

    <div class="container">
        <h2 style="text-align: center;">Danh sách đơn hàng</h2>
        <div class="jumbotron container">
            <div class="row form-group">
                <div class="col-md-5 row">
                    <div class="col-md-6 text-center">
                        <label class="form-group mx-2" for="">Trạng thái Order:</label>
                    </div>
                    <div class="col-md-6">
                        <select class="form-control" name="" id="sel-status">
                            <option value="all">All</option>
                            <option value="open">Open</option>
                            <option value="confirmed">Confirmed</option>
                            <option value="cancel">Cancel</option>
                        </select>
                    </div>
                </div>
                <div class="col-md-5 row">
                    <div class="col-md-6 text-center">
                        <label class="form-group mx-2" for="">Loại Pizza:</label>
                    </div>
                    <div class="col-md-6">
                        <select class="form-control" name="" id="sel-pizza">
                            <option value="all">All</option>
                            <option value="hawaii">Hawaii</option>
                            <option value="bacon">Bacon</option>
                            <option value="seafood">Seafood</option>
                        </select>
                    </div>
                </div>
                <div class="col-md-2 row">
                    <div class="col text-right">
                        <button class="btn btn-success" id="btn-filter"><i class="fas fa-filter"></i> &nbsp;Lọc</button>
                    </div>
                </div>
            </div>
        </div>
        <div class="container-fluid">
            <table class="table table-bordered table-striped table-hover" id="table-orders">
                <thead>
                    <tr>
                        <th>Order ID</th>
                        <th>Kích cỡ Combo</th>
                        <th>Loại Pizza</th>
                        <th>Nước uống</th>
                        <th>Thành tiền</th>
                        <th>Họ và tên</th>
                        <th>Số điện thoại</th>
                        <th>Trạng thái</th>
                        <th>Action</th>
                    </tr>
                </thead>
                <tbody></tbody>
            </table>
        </div>

    </div>
    <script>
        $(document).ready(function () {
            /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
            var gDataOrders = [];
            const gORDER = ["orderCode", "kichCo", "loaiPizza", "idLoaiNuocUong", "thanhTien", "hoTen", "soDienThoai", "trangThai", "action"];
            //Khai báo các cột của datatable
            const gCOL_ORDER_ID = 0;
            const gCOL_KICH_CO = 1;
            const gCOL_LOAI_PIZZA = 2;
            const gCOL_ID_LOAI_NUOC_UONG = 3;
            const gCOL_THANH_TIEN = 4;
            const gCOL_HO_TEN = 5;
            const gCOL_SO_DIEN_THOAI = 6;
            const gCOL_TRANG_THAI = 7;
            const gCOL_ACTION = 8;
            // địNH NGHĨA TABLE - CHƯA CÓ DATA
            $("#table-orders").DataTable({
                "columns": [
                    { "data": gORDER[gCOL_ORDER_ID] },
                    { "data": gORDER[gCOL_KICH_CO] },
                    { "data": gORDER[gCOL_LOAI_PIZZA] },
                    { "data": gORDER[gCOL_ID_LOAI_NUOC_UONG] },
                    { "data": gORDER[gCOL_THANH_TIEN] },
                    { "data": gORDER[gCOL_HO_TEN] },
                    { "data": gORDER[gCOL_SO_DIEN_THOAI] },
                    { "data": gORDER[gCOL_TRANG_THAI] },
                    { "data": gORDER[gCOL_ACTION] }

                ],
                "columnDefs": [
                    {
                        "targets": gCOL_ACTION,
                        "defaultContent": "<button class= 'btn btn-primary btn-detail'>Chi tiet</button>"
                    }
                ]
            })
            /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
            onPageLoading();
            $("#table-orders").on("click", ".btn-detail", function () {
                onBtnDetailClick(this);
            })
            $("#btn-filter").on("click", function () {
                onBtnFilterClick();
            })
            /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
            function onPageLoading() {
                //lấy data từ sever
                $.ajax({

                    url: "http://203.171.20.210:8080/devcamp-pizza365/orders",
                    type: "GET",
                    dataType: 'json',
                    success: function (responseObject) {

                        gDataOrders = responseObject
                        console.log(gDataOrders);
                        //gọi hàm đổ dữ liệu vào bảng
                        loadDataToTable(gDataOrders);
                    },
                    error: function (error) {
                        console.assert(error.responseText);
                    }

                });
            }

            /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình */
            //hàm xử lý đổ dữ liệu vào table
            function loadDataToTable(paramResponseObject) {
                console.log(paramResponseObject);
                var vUserTable = $("#table-orders").DataTable();
                vUserTable.clear();
                vUserTable.rows.add(paramResponseObject);
                vUserTable.draw();
            }
            function onBtnDetailClick(paramElement) {

                var vRowSected = $(paramElement).closest("tr")
                var vTable = $("#table-orders").DataTable();
                var vDataRow = vTable.row(vRowSected).data();
                console.log("ID: " + vDataRow.id);
                console.log("order ID: " + vDataRow.orderCode);
            }
            function onBtnFilterClick() {
                var vStatus = $("#sel-status").val();
                var vPizzaType = $("#sel-pizza").val();
                var vDataFilter = gDataOrders.filter(function (paramOrder, index) {
                    return (vStatus === "all" || vStatus.toUpperCase() === paramOrder.trangThai.toUpperCase())
                        && (vPizzaType === "all" || vPizzaType.toUpperCase() === paramOrder.loaiPizza.toUpperCase())
                });
                loadDataToTable(vDataFilter);
            }
        })
    </script>
</body>

</html>